VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "LinkMappingUnit"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' Fixing hyperlink to server
Option Explicit

Private m_ReplaceMap As Collection

'---------- Public Interface ----------
Public Function FixLink(ByRef adr$, Optional docPath$ = "") As LMU_Return
  Dim testAdr$
  testAdr = FixPrefix(GetFullPath(adr, docPath))
   If testAdr = "" Then
    FixLink = RV_NOTAFSO
    Exit Function
  End If
  
  If CheckFile(testAdr) Then
    If testAdr <> adr Then
      adr = testAdr
      FixLink = RV_LINK_FIXED
    Else
      FixLink = RV_LINK_OK
    End If
    Exit Function
  End If
  
  Dim j&, k&
  Dim rule As LMUItem
  Dim result$
  For j = 1 To m_ReplaceMap.Count
    Set rule = m_ReplaceMap.Item(j)
    If InStr(1, testAdr, rule.repWhat, vbTextCompare) = 0 Then _
      GoTo NEXT_RULE
    
    For k = 1 To rule.repList.Count
      result = Replace(testAdr, rule.repWhat, rule.repList(k))
      If CheckFile(result) Then
        adr = result
        FixLink = RV_LINK_FIXED
        Exit Function
      End If
    Next k
NEXT_RULE:
  Next j
  
  FixLink = RV_LINK_NOFIX
End Function

'---------- Internals ----------
Private Function CheckFile(ByVal addr$) As Boolean
  On Error Resume Next
  CheckFile = Len(Dir(addr)) <> 0 Or Len(Dir(addr, vbDirectory)) <> 0
End Function

Private Sub Class_Initialize()
  Set m_ReplaceMap = New Collection
  Dim rule As LMUItem
    
  Set rule = New LMUItem
  rule.repWhat = "! \Income"
  rule.repList.Add ("00 \01 ")
  Call m_ReplaceMap.Add(rule)
  
  Set rule = New LMUItem
  rule.repWhat = "! \Outcome"
  rule.repList.Add ("00 \02 ")
  Call m_ReplaceMap.Add(rule)
  
  Set rule = New LMUItem
  rule.repWhat = "01 Income-\"
  rule.repList.Add ("! \Income")
  rule.repList.Add ("00 \01 ")
  Call m_ReplaceMap.Add(rule)
  
  Set rule = New LMUItem
  rule.repWhat = "01 Income-"
  rule.repList.Add ("! \Income")
  rule.repList.Add ("00 \01 ")
  Call m_ReplaceMap.Add(rule)
  
  Set rule = New LMUItem
  rule.repWhat = "02 Outcome-"
  rule.repList.Add ("! \Outcome")
  rule.repList.Add ("00 \02 ")
  Call m_ReplaceMap.Add(rule)
  
  Set rule = New LMUItem
  rule.repWhat = "03  "
  rule.repList.Add ("00 \03 ")
  rule.repList.Add ("! \")
  rule.repList.Add ("! \Income")
  rule.repList.Add ("00 \01 ")
  rule.repList.Add ("01 Income-")
  rule.repList.Add ("02 Outcome-")
  Call m_ReplaceMap.Add(rule)
  
  Set rule = New LMUItem
  rule.repWhat = "03 1  "
  rule.repList.Add ("00 \03 ")
  rule.repList.Add ("03  ")
  Call m_ReplaceMap.Add(rule)
  
  Set rule = New LMUItem
  rule.repWhat = "05  \"
  rule.repList.Add ("05  \04 ")
  Call m_ReplaceMap.Add(rule)
End Sub

Private Function FixPrefix(addr$) As String
  FixPrefix = ""
  Dim prefixLen&
  
  prefixLen = Len("P:\")
  If Len(addr) < prefixLen Then Exit Function
  If Left(addr, prefixLen) Like "[Pp]:\" Or Left(addr, prefixLen) Like "[Qq]:\" Then
    FixPrefix = "\\fs1.concept.ru\projects\" + Right(addr, Len(addr) - prefixLen)
    Exit Function
  End If
  If Left(addr, prefixLen) Like "[Xx]:\" Or Left(addr, prefixLen) Like "[Ww]:\" Then
    FixPrefix = "\\fs1.concept.ru\exchange\" + Right(addr, Len(addr) - prefixLen)
    Exit Function
  End If
  
  prefixLen = Len("\\strg1\")
  If Len(addr) < prefixLen Then Exit Function
  If LCase(Left(addr, prefixLen)) Like "\\strg1\" Then
    FixPrefix = "\\fs1.concept.ru\" + Right(addr, Len(addr) - prefixLen)
    Exit Function
  End If
  
  prefixLen = Len("\\server\")
  If Len(addr) < prefixLen Then Exit Function
  If LCase(Left(addr, prefixLen)) = "\\server\" Then
    FixPrefix = "\\fs1.concept.ru\" + Right(addr, Len(addr) - prefixLen)
    Exit Function
  End If
  
  prefixLen = Len("\\fs1.concept.ru\")
  If Len(addr) < prefixLen Then Exit Function
  If LCase(Left(addr, prefixLen)) = "\\fs1.concept.ru\" Then
    FixPrefix = addr
    Exit Function
  End If
End Function


